/******************************************************************************
 * CLASSIFICATION: UNLASSIFIED//FOUO>
 *
 * Copyright(C) ProLogic, Incorporated 2008, 1000 Technology Drive, Fairmont, WV 26554
 * Produced pursuant to U.S. Government sponsorship.
 * 
 * Copyright applies to commercial uses only.   Notwithstanding the above
 * copyright/restriction, the Government possesses DFARS 252.227-7013. 
 * Unlimited Rights if this is technical data and DFARS 252.227-7014. 
 * Unlimited Rights if this is computer software or computer software 
 * documentation.
 * 
 * $Id: $
 *****************************************************************************/
/**
 * @file TestUtils.cpp
 * Main header file for the PROJECT_NAME application.
 * 
 * @todo Fix file description.
 */


#include "TestUtils.h"
#include "Convert.h"
#include "StringUtils.h"
#include <ostream>
#include <vector>
#include <algorithm>
#include <iterator>


using namespace std;
using namespace boost;



ostream& operator<<( ostream& o, const wstring& str )
{
	o << CStringUtils::Narrow( str );
	return o;
}



template<class Cont>
static inline ostream& _Outputter( ostream& o, const Cont& cont )
{
	ostream_iterator<Cont::value_type> os(o, ", ");
	copy( cont.begin(), cont.end(), os );
	return o;
}


//output vectors

ostream& operator<<( ostream& o, const vector<uint8_t>& vec ) //uint8 gets special treatment
{
	if( vec.size() > 0 ) 
	{
		const string strHex = CConvert::BinToHexStringA( &vec[0], vec.size());
		o << strHex;
	}
	return o;
}

ostream& operator<<( ostream& o, const vector<uint16_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const vector<uint32_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const vector<uint64_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const vector<int8_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const vector<int16_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const vector<int32_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const vector<int64_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const vector<float>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const vector<double>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const vector<long double>& vec )
{
	return _Outputter( o, vec );
}


//output lists

ostream& operator<<( ostream& o, const list<uint8_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<uint16_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<uint32_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<uint64_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<int8_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<int16_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<int32_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<int64_t>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<float>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<double>& vec )
{
	return _Outputter( o, vec );
}

ostream& operator<<( ostream& o, const list<long double>& vec )
{
	return _Outputter( o, vec );
}

