/******************************************************************************
 * CLASSIFICATION: UNLASSIFIED//FOUO>
 *
 * Copyright(C) ProLogic, Incorporated 2008, 1000 Technology Drive, Fairmont, WV 26554
 * Produced pursuant to U.S. Government sponsorship.
 * 
 * Copyright applies to commercial uses only.   Notwithstanding the above
 * copyright/restriction, the Government possesses DFARS 252.227-7013. 
 * Unlimited Rights if this is technical data and DFARS 252.227-7014. 
 * Unlimited Rights if this is computer software or computer software 
 * documentation.
 * 
 * $Id: $
 *****************************************************************************/
/**
 * @file TestUtils.h
 * Main header file for the PROJECT_NAME application.
 * 
 * @todo Fix file description.
 */


#pragma once

//This place is meant to be a dumping ground for generally useful utility functions
//to help the tests themselved be platform portable.
//
//We'll probably end up with several factory functions in here.

#include "boost/cstdint.hpp"
#include <string>
#include <ostream>
#include <vector>
#include <list>


//dumps a wide string to a narrow ostream
std::ostream& operator<<( std::ostream& o, const std::wstring& str );


//copies a container to an output stream
std::ostream& operator<<( std::ostream& o, const std::vector<boost::uint8_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<boost::uint16_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<boost::uint32_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<boost::uint64_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<boost::int8_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<boost::int16_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<boost::int32_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<boost::int64_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<float>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<double>& vec );
std::ostream& operator<<( std::ostream& o, const std::vector<long double>& vec );

std::ostream& operator<<( std::ostream& o, const std::list<boost::uint8_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<boost::uint16_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<boost::uint32_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<boost::uint64_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<boost::int8_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<boost::int16_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<boost::int32_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<boost::int64_t>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<float>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<double>& vec );
std::ostream& operator<<( std::ostream& o, const std::list<long double>& vec );
